/*
 * Simple Framework v0.8
 *
 * A simple Framework for coding Director apps in JavaScript (or Lingo)
 * without the Director IDE
 *
 * Copyleft 2012, Valentin Schmidt
 * Date: 2012-06-23
 *
 * Contains some Code from jQuery 1.7.1
 * http://jquery.org/license
 */

this.scriptfile = "framework.js"; // useful for debugging

(function(root){

var framework = (function() {

///// PUBLIC PROPERTIES //////////////////////////

this.CATCH = "var locals={};for(i in arguments.callee)locals[i]=eval(i);$.traceError(arguments.callee.name,e,scriptfile,locals);";
this.CATCHBREAK = this.CATCH + "$.alert('PRESS TO CONTINUE');";
this.BREAK = "var more=more?more:false;var locals={};for(i in arguments.callee)locals[i]=eval(i);var err;try{_()}catch(e){err=e};$.breakpoint(arguments.callee.name,err.lineNumber,scriptfile,locals,more);"
this.PD = _movie.path.substr(-1);
this.MP = _movie.path;
this.OFFSTAGE = point(2000,2000);

///// PUBLIC VARIABLES ///////////////////////////

var frameScriptList = false;
var class2type = {};
var uid = 0;

// Used for trimming whitespace
var
trimLeft = /^\s+/,
trimRight = /\s+$/;

// JSON RegExp
var
rvalidchars = /^[\],:{}\s]*$/,
rvalidescape = /\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,
rvalidtokens = /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,
rvalidbraces = /(?:^|:|,)(?:\s*\[)+/g;

var	escapeable = /["\\\x00-\x1f\x7f-\x9f]/g, //"
	meta = {
		'\b': '\\b',
		'\t': '\\t',
		'\n': '\\n',
		'\f': '\\f',
		'\r': '\\r',
		'"' : '\\"',
		'\\': '\\\\'
	};
		
// Save a reference to some core methods
var toString = Object.prototype.toString,
hasOwn = Object.prototype.hasOwnProperty,
push = Array.prototype.push,
slice = Array.prototype.slice,
trim = String.prototype.trim,
indexOf = Array.prototype.indexOf;

///// CONSOLE API ////////////////////////////////

// SET ALERTHOOK (ONLY FOR UNCAUGHT EXCEPTIONS)
this.setAlertHook = function(){
	_player.alertHook = {
		alertHook: function(err, msg, type){
		  switch (type.toString()){
		    case ("#alert"):
		    	return 0;
		    default:				
					var e = {message:msg, toString:function(){return err+" (Type:"+type+")"}};
					//traceError(fn,e,scriptfile,locals)
					$.traceError(undefined, e);
		    return 1;
		  }
		}
	};
};

// uses Director's message window by default
this.log = function(){
	trace.apply(null, arguments);
}

// not availble (empty) in default implementation
this.clear = function(){}

// show (recursive) structured information about an object/array
this.dir = function(obj,   returnFlag, title){
	function _parse(x, indent, aTitle){
		if (!indent) indent='';
		var ret = "\n";
	  var t = f.type(x); //(typeof x)
	  var s = (aTitle?aTitle:t) + ret;
	  if (t=='propList'||t=='list'){
	  	s += indent+'  '+x.toString() + ret;
	  }else {//x = f.makeObject(x);
	  	indent += '  ';
	  	if (x.length){
	  		for (var i=0;i<x.length;i++){
			    if (typeof x[i]=='object') s += indent + i + ': ' + _parse(x[i], indent);
			  	else
			  		s += indent + i + ': ' + x[i] + ret; //+ ' ('+(typeof x[i])
	  		}
	  	}else{
			  for (var i in x){
			    //s += indent + i + ': ' + x[i] + ' ('+(typeof x[i]) + ")"+ret;
			    if (typeof x[i]=='object') s += indent + i + ': ' + _parse(x[i], indent);
			  	else
			  		s += indent + i + ': ' + x[i] + ret; //+ ' ('+(typeof x[i])
			  }
			}
		}
	  return s;
	}
	var f = this;
	var s = _parse(obj, '', title);
  if (returnFlag) return s;
  else this.log(s);
}

// show an error message
this.error = function(){
	var s = "\n";
	s += "##################################################\n";
	s += "# ERROR                                          #\n"; 
	s += "##################################################\n";
	this.log(s);
	this.log.apply(this, arguments);
	this.log("**************************************************\n\n");
}

// show a warning
this.warn = function(){
	var s = "\n";
	s += "##################################################\n";
	s += "# WARNING                                        #\n"; 
	s += "##################################################\n";
	this.log(s);
	this.log.apply(this, arguments);
	this.log("**************************************************\n\n");
}

// show an info message
this.info = function(){
	var s = "\n";
	s += "##################################################\n";
	s += "# INFO                                           #\n"; 
	s += "##################################################\n";
	this.log(s);
	this.log.apply(this, arguments);
	this.log("**************************************************\n\n");
}

///// ERROR/OUTPUT RELATED ///////////////////////

// show error details as provided by the CATCH/CATCHBREAK macros
this.traceError = function(fn,e,scriptfile,locals){
	var s = "Error: "+e+"\n";
	s += "Message: "+e.message+"\n";
	if (scriptfile) s += "Script: "+scriptfile+"\n"; //s += "fileName: "+e.fileName+"\n";
	if (fn!==undefined) s += "Function Name: "+fn+"\n";
	if (e.lineNumber!==undefined) s += "Line Number: "+e.lineNumber+"\n";
	if (e.stack!==undefined) s += "Stack:\n"+e.stack;
	if (locals!==undefined)s += this.dir(locals,1,"Local Variables:"); //if (locals) {
	this.error(s);
	var w=window('console');
	w.moveToFront();
	w.movie.updateStage();
	//if (_player.alertHook) _player.alertHook.alertHook("Script runtime error", e.toString(), "#script", e.stack);
}

// show breakpoint info in console
this.breakpoint = function(fn,ln,scr,locals,more){
	var s = "\n";
	s += "##################################################\n";
	s += "# BREAKPOINT                                     #\n";
	s += "##################################################\n";
	if (scr) s += "Script: "+scr+"\n";
	s += "Function Name: "+fn+"\n";
	s += "Line Number: "+ln+"\n";
	s += this.dir(locals,1,"Local Variables:");
	if (more) s += this.dir(more,1,"More Info:");
	this.log(s);
	this.log("**************************************************\n\n");
	var w=window('console');
	w.moveToFront();
	w.movie.updateStage();
	this.alert('PRESS TO CONTINUE');
}

// show alert, taking care of non-string variable types
this.alert = function(o){
	_player.alert(o.toString());
}

// evaluate in framework (or specified object's) scope
this.eval = function(code, scope){
	if (!scope) scope=this;
	return eval.call(scope, code)
}


this.throwError = function( msg ) {
	throw new Error( msg );
};

///// MEMBER /////////////////////////////////////

// cLib can be string, number or castLibRef
// properties of object props are applied to new member
this.newMember = function(type, cLib, props){
	var m;
	if (this.isPlainObject(cLib)){
		props = cLib;
		cLib = false;
	}
	if (cLib){
		if (typeof cLib=="string" || typeof cLib=="number") cLib = castLib(cLib);
		m = _movie.newMember(type, cLib);
	}else{
		m = _movie.newMember(type);
	}
	if (m && props) this.applyProps(m, props);
	return m;
};

///// SPRITES ////////////////////////////////////

// returns array of sprites that meet condition prop==val
this.select = function(prop, val){
	var a = [];
	for (var i=1;i<=_movie.lastChannel;i++){
		if (sprite(i).member.type && sprite(i)[prop] && sprite(i)[prop]==val) a.push(sprite(i));
	}
	return a;
}

this.freeChannel = function(){
	for (var i=1;i<=_movie.lastChannel;i++){
		if (!sprite(i).member.type) return i;
	}
	return false;
};

this.newSprite = function(m, loc, spriteProps, customProps){ // hidden, ID, CLASS,
	if (!customProps) customProps={}
	if (!customProps.ID) customProps.ID = "";
	if (!customProps.CLASS) customProps.CLASS = "";
	if (!customProps.hidden) customProps.hidden = false;
	customProps.pos = loc;
	customProps.children = [];
	var n = this.freeChannel();
	channel(n).makeScriptedSprite(m, customProps.hidden?this.OFFSTAGE:loc);
	if (spriteProps) this.applyProps(sprite(n), spriteProps);
	sprite(n).scriptInstanceList = list(customProps);
	return sprite(n);	
}

this.removeSprite = function(s){
	if (this.isArray(s)){
		for (var i in s) this.removeSprite(s[i]);
		return;
	}
	for (var i in s.children){
		this.removeSprite(s.children[i]);
	}
	channel(s.spriteNum).removeScriptedSprite();
};

this.newChildSprite = function(parent, m, loc, spriteProps, customProps){
	var parentLoc = parent.hidden?parent.pos:parent.loc;
	loc.locH += parentLoc.locH;
	loc.locV += parentLoc.locV;
	if (!customProps) customProps={}
	if (!customProps.ID) customProps.ID = "";
	if (!customProps.CLASS) customProps.CLASS = "";
	if (!customProps.hidden) customProps.hidden = false;
	customProps.pos = loc;
	customProps.children = [];
	//customProps.parent = parent; // ???
	var n = this.freeChannel();
	channel(n).makeScriptedSprite(m, customProps.hidden||parent.hidden?this.OFFSTAGE: (loc) );
	if (spriteProps) this.applyProps(sprite(n), spriteProps);
	sprite(n).scriptInstanceList = list(customProps);
	parent.children.push(sprite(n));
	return sprite(n);	
}

this.show = function(s, keepFlag){
	if (this.isArray(s)){
		for (var i in s) this.show(s[i], keepFlag);
		return;
	}
	//if (!s.hidden) return;
	if (!keepFlag) s.hidden = false;
	if (!s.hidden) s.loc = s.pos;
	for (var i in s.children){
		this.show(s.children[i], 1);
	}
}

this.hide = function(s, keepFlag){
	if (this.isArray(s)){
		for (var i in s) this.hide(s[i], keepFlag);
		return;
	}
	if (s.hidden) return;
	if (!keepFlag) s.hidden = true;
	s.pos = s.loc;
	s.loc = this.OFFSTAGE;
	for (var i in s.children){
		this.hide(s.children[i], 1);
	}
}

this.toggle = function(s){
	if (this.isArray(s)){
		for (var i in s) this.toggle(s[i]);
		return;
	}
	if (s.hidden) this.show(s);
	else this.hide(s);
}

this.moveto = function(s, loc){
	if (this.isArray(s)){
		for (var i in s) this.moveto(s[i], loc);
		return;
	}
	var dx = loc.locH-(s.hidden?s.pos.locH:s.locH);
	var dy = loc.locV-(s.hidden?s.pos.locV:s.locV);
	this.moveby(s, point(dx,dy));
}

this.moveby = function(s, loc){
	if (this.isArray(s)){
		for (var i in s) this.moveby(s[i], loc);
		return;
	}
	if (s.hidden){
		s.pos.locH += loc.locH;
		s.pos.locV += loc.locV;
	}else{
		s.locH += loc.locH;
		s.locV += loc.locV;
	}
	for (var i in s.children){
		this.moveby(s.children[i], loc);
	}
}

// TODO:
// animate(s, {prop1: targetValue1, ...}, duration, completeCallback)
// support multiple classes -> change select behaviour
// add more class related functions:
// addClass()
// hasClass()
// removeClass()

///// FRAME SCRIPTS //////////////////////////////

this.addFrameScript = function(obj){
	if (frameScriptList){
		frameScriptList.add(obj);
	}else{
		frameScriptList = list(obj);
		sprite(0).scriptInstanceList = frameScriptList;
	}
}

this.removeFrameScript = function(obj){
	if (frameScriptList){
		this.listDeleteOne(frameScriptList, obj);
	}
}

this.setFrameLoop = function(){
	this.addFrameScript( {exitFrame:function(){_movie.go(_movie.frame);}} );
}

///// LIST/ARRAY/PROPLIST/OBJECT CONVERSION //////

this.makeArray = function(lingoList){
	var a = Array();
	var v;
	var cnt = lingoList.count;
	for (var i=1;i<=cnt;i++){
		v = lingoList[i];
		if (v.ilk){
			var t = v.ilk();
			if (t=="#propList") v = this.makeObject(v);
			else if (t=="#list") v = this.makeArray(v);
		}
		a.push(v);
	}
	return a;
};

this.makeList = function(jsArray){
	if (!this.isArray(jsArray)) return false;
	var l = list();
	var v;
	var cnt = jsArray.length;
	for (var i=0;i<cnt;i++){
		v = jsArray[i];
		if (this.isArray(v)) v = this.makeList(v);
		else if (this.isPlainObject(v)) v = this.makePropList(v);
		l.add(v);
	}
	return l;
};

// BUG? -> doesn't work with bytearray values?
this.makeObject = function(propList){
	var obj = {};
	var p, v;
	var cnt = propList.count;
	for (var i=1;i<=cnt;i++){
		v = propList.getAt(i);
		if (v.ilk){
			var t = v.ilk();
			if (t=="#propList") v = this.makeObject(v);
			else if(t=="#list") v = this.makeArray(v);
		}
		p = propList.getPropAt(i);
		if (p.ilk && p.ilk()=="#symbol") p = p.toString().substr(1); //???
		obj[p] = v;
	}
	return obj;
};

this.makePropList = function(jsObject){
	if (!this.isPlainObject(jsObject)) return false;
	var pl = propList();
	var v;
	for (var i in jsObject){
		v = jsObject[i];
		if (this.isArray(v)) v = this.makeList(v);
		else if (this.isPlainObject(v)) v = this.makePropList(v);
		pl.addProp(i, v);
	}
	return pl;
};

////////// UTILITIES /////////////////////////////

this.getUID = function(){
	uid++;
	return uid;
}

// args is for internal usage only
this.each = function( object, callback, args ) {
	var name, i = 0,
		length = object.length,
		isObj = length === undefined || this.isFunction( object );
	if ( args ) {
		if ( isObj ) {
			for ( name in object ) {
				if ( callback.apply( object[ name ], args ) === false ) {
					break;
				}
			}
		} else {
			for ( ; i < length; ) {
				if ( callback.apply( object[ i++ ], args ) === false ) {
					break;
				}
			}
		}
	// A special, fast, case for the most common use of each
	} else {
		if ( isObj ) {
			for ( name in object ) {
				if ( callback.call( object[ name ], name, object[ name ] ) === false ) {
					break;
				}
			}
		} else {
			for ( ; i < length; ) {
				if ( callback.call( object[ i ], i, object[ i++ ] ) === false ) {
					break;
				}
			}
		}
	}
	return object;
};

this.listDeleteOne = function(l, obj){
	var cnt = l.count;
	for (var i=1;i<=cnt;i++){
		if (l[i]==obj){
			l.deleteAt(i);
			return;
		}
	}
};

this.applyProps = function(obj, props){
	for (var i in props){
		obj[i] = props[i];
	}
};

this.prop = function(selection, prop, val){
	for (var i in selection){
		selection[i][prop] = val;
	}
}

this.type = function( obj ) {
	return obj == null ?
		String( obj ) :
		class2type[ toString.call(obj) ] || (obj.ilk ? obj.ilk().toString().substr(1) : "object");
};

this.isArray = Array.isArray || function( obj ) {
	return this.type(obj) === "array";
};

this.isFunction = function( obj ) {
	return this.type(obj) === "function";
};

this.isNumeric = function( obj ) {
	return !isNaN( parseFloat(obj) ) && isFinite( obj );
}

this.isPlainObject = function( obj ) {
	// Must be an Object.
	if ( !obj || this.type(obj) !== "object" ) {
		return false;
	}
	// Own properties are enumerated firstly, so to speed up,
	// if last one is own, then all properties are own.
	var key;
	for ( key in obj ) {}
	return key === undefined || hasOwn.call( obj, key );
};

this.isEmptyObject = function( obj ) {
	for ( var name in obj ) {
		return false;
	}
	return true;
};

this.inArray = function( elem, array, i ) {
	var len;
	if ( array ) {
		if ( indexOf ) {
			return indexOf.call( array, elem, i );
		}
		len = array.length;
		i = i ? i < 0 ? Math.max( 0, len + i ) : i : 0;
		for ( ; i < len; i++ ) {
			// Skip accessing in sparse arrays
			if ( i in array && array[ i ] === elem ) {
				return i;
			}
		}
	}
	return -1;
};

this.merge = function( first, second ) {
	var i = first.length,	j = 0;
	if ( typeof second.length === "number" ) {
		for ( var l = second.length; j < l; j++ ) {
			first[ i++ ] = second[ j ];
		}
	} else {
		while ( second[j] !== undefined ) {
			first[ i++ ] = second[ j++ ];
		}
	}
	first.length = i;
	return first;
};

this.grep = function( elems, callback, inv ) {
	var ret = [], retVal;
	inv = !!inv;
	for ( var i = 0, length = elems.length; i < length; i++ ) {
		retVal = !!callback( elems[ i ], i );
		if ( inv !== retVal ) {
			ret.push( elems[ i ] );
		}
	}
	return ret;
};

// arg is for internal usage only
this.map = function( elems, callback, arg ) {
	var value, key, ret = [],
		i = 0,
		length = elems.length,
		isArray = length !== undefined && typeof length === "number" && ( ( length > 0 && elems[ 0 ] && elems[ length -1 ] ) || length === 0 || this.isArray( elems ) ) ;
	// Go through the array, translating each of the items to their
	if ( isArray ) {
		for ( ; i < length; i++ ) {
			value = callback( elems[ i ], i, arg );
			if ( value != null ) {
				ret[ ret.length ] = value;
			}
		}
	// Go through every key on the object,
	} else {
		for ( key in elems ) {
			value = callback( elems[ key ], key, arg );
			if ( value != null ) {
				ret[ ret.length ] = value;
			}
		}
	}
	// Flatten any nested arrays
	return ret.concat.apply( [], ret );
};

// Use native String.trim function wherever possible
this.trim = function( text ) {
	return text == null ?
		"" :
		text.toString().replace( trimLeft, "" ).replace( trimRight, "" );
};

this.parseJSON = function( data ) {
	if (typeof data!=="string"||!data) {
		return null;
	}
	if ( rvalidchars.test( data.replace( rvalidescape, "@" )
		.replace( rvalidtokens, "]" )
		.replace( rvalidbraces, "")) ) {
		return ( new Function( "return " + data ) )();
	}
	this.throwError("Invalid JSON: " + data);
};




/**
 * jQuery.toJSON
 * Converts the given argument into a JSON respresentation.
 *
 * @param o {Mixed} The json-serializble *thing* to be converted
 *
 * If an object has a toJSON prototype, that will be used to get the representation.
 * Non-integer/string keys are skipped in the object, as are keys that point to a
 * function.
 *
 */
this.toJSON = function( o ) {
	if ( o === null ) {
		return 'null';
	}
	var type = typeof o;

	if ( type === 'undefined' ) {
		return undefined;
	}
	if ( type === 'number' || type === 'boolean' ) {
		return '' + o;
	}
	if ( type === 'string') {
		return this.quoteString( o );
	}
	if ( type === 'object' ) {
		if ( typeof o.toJSON === 'function' ) {
			return this.toJSON( o.toJSON() );
		}
		if ( o.constructor === Date ) {
			var	month = o.getUTCMonth() + 1,
				day = o.getUTCDate(),
				year = o.getUTCFullYear(),
				hours = o.getUTCHours(),
				minutes = o.getUTCMinutes(),
				seconds = o.getUTCSeconds(),
				milli = o.getUTCMilliseconds();

			if ( month < 10 ) {
				month = '0' + month;
			}
			if ( day < 10 ) {
				day = '0' + day;
			}
			if ( hours < 10 ) {
				hours = '0' + hours;
			}
			if ( minutes < 10 ) {
				minutes = '0' + minutes;
			}
			if ( seconds < 10 ) {
				seconds = '0' + seconds;
			}
			if ( milli < 100 ) {
				milli = '0' + milli;
			}
			if ( milli < 10 ) {
				milli = '0' + milli;
			}
			return '"' + year + '-' + month + '-' + day + 'T' +
				hours + ':' + minutes + ':' + seconds +
				'.' + milli + 'Z"';
		}
		if ( o.constructor === Array ) {
			var ret = [];
			for ( var i = 0; i < o.length; i++ ) {
				ret.push( this.toJSON( o[i] ) || 'null' );
			}
			return '[' + ret.join(',') + ']';
		}
		var	name,
			val,
			pairs = [];
		for ( var k in o ) {
			type = typeof k;
			if ( type === 'number' ) {
				name = '"' + k + '"';
			} else if (type === 'string') {
				name = this.quoteString(k);
			} else {
				// Keys must be numerical or string. Skip others
				continue;
			}
			type = typeof o[k];

			if ( type === 'function' || type === 'undefined' ) {
				// Invalid values like these return undefined
				// from toJSON, however those object members
				// shouldn't be included in the JSON string at all.
				continue;
			}
			val = this.toJSON( o[k] );
			pairs.push( name + ':' + val );
		}
		return '{' + pairs.join( ',' ) + '}';
	}
};

/**
 * jQuery.quoteString
 * Returns a string-repr of a string, escaping quotes intelligently.
 * Mostly a support function for toJSON.
 * Examples:
 * >>> jQuery.quoteString('apple')
 * "apple"
 *
 * >>> jQuery.quoteString('"Where are we going?", she asked.')
 * "\"Where are we going?\", she asked."
 */
this.quoteString = function( string ) {
	if ( string.match( escapeable ) ) {
		return '"' + string.replace( escapeable, function( a ) {
			var c = meta[a];
			if ( typeof c === 'string' ) {
				return c;
			}
			c = a.charCodeAt();
			return '\\u00' + Math.floor(c / 16).toString(16) + (c % 16).toString(16);
		}) + '"';
	}
	return '"' + string + '"';
};

this.doTimeout = function(period, callback, args){
	var target = {
		callback: callback,
		args: args?args:[],
		done:function(t){
			t.forget();
			callback.apply(0, this.args);
		}
	}
	return new timeout(this.getUID().toString(), period, symbol("done"), target);
};

this.doInterval = function(period, callback, args){
	var target = {
		callback: callback,
		args: args?args:[],
		done:function(t){
			callback.apply(0, this.args);
		}
	}
	return new timeout(this.getUID().toString(), period, symbol("done"), target);
};

// taken from jQuery
this.extend = function() {
	var options, name, src, copy, copyIsArray, clone,
		target = arguments[0] || {},
		i = 1,
		length = arguments.length,
		deep = false;
	// Handle a deep copy situation
	if ( typeof target === "boolean" ) {
		deep = target;
		target = arguments[1] || {};
		// skip the boolean and the target
		i = 2;
	}
	// Handle case when target is a string or something (possible in deep copy)
	if ( typeof target !== "object" && !this.isFunction(target) ) {
		target = {};
	}
	// extend framework itself if only one argument is passed
	if ( length === i ) {
		target = this;
		--i;
	}
	for ( ; i < length; i++ ) {
		// Only deal with non-null/undefined values
		if ( (options = arguments[ i ]) != null ) {
			// Extend the base object
			for ( name in options ) {
				src = target[ name ];
				copy = options[ name ];
				// Prevent never-ending loop
				if ( target === copy ) {
					continue;
				}
				// Recurse if we're merging plain objects or arrays
				if ( deep && copy && ( this.isPlainObject(copy) || (copyIsArray = this.isArray(copy)) ) ) {
					if ( copyIsArray ) {
						copyIsArray = false;
						clone = src && this.isArray(src) ? src : [];
					} else {
						clone = src && this.isPlainObject(src) ? src : {};
					}
					// Never move original objects, clone them
					target[ name ] = this.extend( deep, clone, copy );
				// Don't bring in undefined values
				} else if ( copy !== undefined ) {
					target[ name ] = copy;
				}
			}
		}
	}
	// Return the modified object
	return target;
};

this.quit = function(){
	//_player.quit();	
	//_movie.halt();
	$.doTimeout(1, _player.quit);
}

// INIT PRIVATE VARS

// Populate the class2type map
this.each("Boolean Number String Function Array Date RegExp Object".split(" "), function(i, name) {
	class2type[ "[object " + name + "]" ] = name.toLowerCase();
});

}); // END FRAMEWORK


root.$ = new framework();


})( _global );
