this.scriptfile = "framework_net.js"; // useful for debugging

$.get = function(url, callback, vars){
	var n = {};
	if (!vars) vars = "";
	n.pNetID = getNetText(url, vars);
	n.callback = callback;
	n.stepFrame = function(){
		if (netDone(this.pNetID)){
			$.listDeleteOne(_movie.actorList, this);
			if (this.callback) this.callback(netTextResult(this.pNetID), netError(this.pNetID));
			else $.log(netTextResult(this.pNetID), netError(this.pNetID));
		}
	};
	_movie.actorList.add(n);
}

$.post = function(url, callback, vars){
	var n = {};
	if (!vars) vars = "";
	n.pNetID = postNetText(url, vars);
	n.callback = callback;
	n.stepFrame = function(){
		if (netDone(this.pNetID)){
			$.listDeleteOne(_movie.actorList, this);
			if (this.callback) this.callback(netTextResult(this.pNetID), netError(this.pNetID));
			else $.log(netTextResult(this.pNetID), netError(this.pNetID));
		}
	};
	_movie.actorList.add(n);
}

$.getBytes = function(url, callback, vars){
	var n = {};
	if (!vars) vars = "";
	n.pNetID = getNetBytearray(url, vars);
	n.callback = callback;
	n.stepFrame = function(){
		if (netDone(this.pNetID)){
			$.listDeleteOne(_movie.actorList, this);
			if (this.callback) this.callback(netBytearrayResult(this.pNetID), netError(this.pNetID));
			else $.log(netBytearrayResult(this.pNetID), netError(this.pNetID));
		}
	};
	_movie.actorList.add(n);
}

$.postBytes = function(url, callback, vars){
	var n = {};
	if (!vars) vars = "";
	n.pNetID = postNetBytearray(url, vars);
	n.callback = callback;
	n.stepFrame = function(){
		if (netDone(this.pNetID)){
			$.listDeleteOne(_movie.actorList, this);
			if (this.callback) this.callback(netBytearrayResult(this.pNetID), netError(this.pNetID));
			else $.log(netBytearrayResult(this.pNetID), netError(this.pNetID));
		}
	};
	_movie.actorList.add(n);
}

$.download = function(url, filename, callback, progressCallback){
	var n = {};
	n.url = url;
	n.filename = filename;
	n.pNetID = downloadNetThing(url, filename);
	n.callback = callback;
	n.progressCallback = progressCallback;
	n.stepFrame = function(){
		var info = getStreamStatus(this.pNetID);
		if (this.progressCallback && info.bytesTotal){
			this.progressCallback(info.bytesSoFar/info.bytesTotal);
		}
		if (netDone(this.pNetID)){
			$.listDeleteOne(_movie.actorList, this);
			if (this.callback) this.callback(this.url, this.filename, netError(this.pNetID));
			else $.log(this.url, this.filename, netError(this.pNetID));
		}
	};
	_movie.actorList.add(n);
};

$.preload = function(url, callback){
	var n = {};
	n.url = url;
	n.pNetID = preloadNetThing(url);
	n.callback = callback;
	n.stepFrame = function(){
		var info = getStreamStatus(this.pNetID);
		if (this.progressCallback && info.bytesTotal){
			this.progressCallback(info.bytesSoFar/info.bytesTotal);
		}
		if (netDone(this.pNetID)){
			$.listDeleteOne(_movie.actorList, this);
			if (this.callback) this.callback(this.url, netError(this.pNetID));
			else $.log(this.url, netError(this.pNetID));
		}
	};
	_movie.actorList.add(n);
};
