/*
 * Flickr Demo v0.1
 *
 * Copyleft 2012, Valentin Schmidt
 * Date: 2012-06-23
 *
 * Requirements:
 * - JS framework (framework.js, framework_console.js, framework_net.js)
 * - fileIO xtra, netLingo xtras
 * - sha1.js
 */

this.scriptfile = "main.js"; // useful for debugging

// STATIC VARS

// ADD YOUR OWN VALUES HERE INSTEAD! -----------------------
var oauth_consumer_key = "768fe946d252b119746fda82e1599980"; // wackylabs test key
var oauth_consumer_secret = "1a3c208e172d3edc"; // wackylabs test secret
var oauth_callback = "http://valentin.dasdeck.com/lingo/oauth_class/oauth_callback.php";
// ---------------------------------------------------------

var btn;
var btnSprite;

var field;
var fieldSprite;

//--------------------------------------
// EVENT HANDLER CALLED BY RUNTIME
//--------------------------------------
function prepareMovie(){
	try{

	// SHOW JS DEBUGGING CONSOLE
	if ($.jsconsole) $.jsconsole.open();

	// SET DEFAULT ALERTHOOK (ONLY USED FOR UNCAUGHT EXCEPTIONS)
	$.setAlertHook();

	// MAKE PLAYHEAD LOOP ON CURRENT FRAME
	$.setFrameLoop();

	OAuth.set_consumer_key(oauth_consumer_key, oauth_consumer_secret);
	
	// DELETE THE PREF FILES TO TEST AUTHENTICATION AGAIN!
	if (_player.getPref("access_token") && _player.getPref("access_token_secret")){

		$.log("Application is already authenticated to use the Flickr API!");
		OAuth.set_access_token(_player.getPref("access_token"), _player.getPref("access_token_secret"));
		testApi();

	}else{

    var base_url = "http://www.flickr.com/services/oauth/request_token";
    var oauth_callback = "http://valentin.dasdeck.com/lingo/oauth_class/oauth_callback.php";

    OAuth.get_request_token(base_url, oauth_callback, function(success, err){
      if(!success){
        $.log("ERROR: "+err);
      }else{
        verify();
      }
    });
    
	}

	}catch(e){eval($.CATCH);}
}

function stopMovie(){
  if (OAuth.oauth_access_token && OAuth.oauth_access_token_secret){
    // SAVE AS PREFS
    _player.setPref("access_token", OAuth.oauth_access_token);
    _player.setPref("access_token_secret", OAuth.oauth_access_token_secret);
  }
  member("verifier").text = "";
}

//--------------------------------------
// creates TEST API screen
//--------------------------------------
function testApi(){
	
	// CREATE TEST API BUTTON
	btn = $.newMember("button", "", {text:"Test Flickr API", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	btnSprite1 = $.newSprite(btn, point(160-btn.width/2, 120-2*btn.height), {}, {
		mouseUp:function(){
		  var base_url = "http://api.flickr.com/services/rest";
		  var param_obj = {
		    format: "json",
		    method: "flickr.test.login",
		    nojsoncallback: 1
		  }
		  OAuth.call_api(base_url, param_obj, function(success, str){
		    if(!success){
		      $.log("ERROR: "+str);
		    }else{
		      $.log("RESULT: "+str);
		    }
		  });
		}
	});
	
	// CREATE RE-AUTHENTICATE BUTTON
	btn = $.newMember("button", "", {text:"Re-Authenticate", font:"Arial", fontsize:14, fontstyle:"plain", textAlign:"center"});
	btnSprite2 = $.newSprite(btn, point(160-btn.width/2, 120+btn.height), {}, {
		mouseUp:function(){
		  // clear
		  _player.setPref("access_token", "");
		  _player.setPref("access_token_secret", "");
		  OAuth.set_access_token("", "");
		  
		  var base_url = "http://www.flickr.com/services/oauth/request_token";
		  var oauth_callback = "http://valentin.dasdeck.com/lingo/oauth_class/oauth_callback.php";
		  
		  OAuth.get_request_token(base_url, oauth_callback, function(success, err){
		    if(!success){
		      $.log("ERROR: "+err);
		    }else{
		      $.removeSprite(btnSprite1);
		      $.removeSprite(btnSprite2);
		      verify();
		    }
		  });
		}
	});
		
}

//--------------------------------------
// creates VERIFY screen
//--------------------------------------
function verify(){
	
	// CREATE FIELD
	var defaultTxt = " enter verifier value here ";
	field = $.newMember("field", "", {text:defaultTxt, font:"Arial", fontsize:14, textAlign:"center", border:1, editable:1, boxType:symbol("fixed")});
	fieldSprite = $.newSprite(field, point(160-field.width/2, 100), {}, {
		mouseDown:function(){
			if (field.text = defaultTxt) field.text = "";
		}
	});
	
	// CREATE BUTTON
	btn = $.newMember("button", "", {text:" OK ", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	btnSprite = $.newSprite(btn, point(160-btn.width/2, 100+fieldSprite.height+20), {}, {
		mouseUp:function(){
			if (field.text!="" && field.text!=defaultTxt){

				OAuth.set_verifier(field.text);
	  		var base_url = "http://www.flickr.com/services/oauth/access_token";
	  		
			  OAuth.get_access_token(base_url, function(success, err, data){
			    if(!success){
			      trace("ERROR: "+err);
			       if (data) $.dir(data);
			    }else{
			
			      trace("Access token was succesfully saved!");
						$.removeSprite(fieldSprite);
						$.removeSprite(btnSprite);

			      testApi(); 
			    }
			  });
  	
			}
		}
	});
		
	// OPEN IN DEFAULT BROWSER
	OAuth.authorize("http://www.flickr.com/services/oauth/authorize");
	
}
